<?php
/** 
 *	iCagenda - iC calendar
 *----------------------------------------------------------------------------
 * @package     com_icagenda
 * @copyright	Copyright (C) 2012 JOOMLIC - All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Jooml!C - http://www.joomlic.com
 * 
 * @since		1.2
 *----------------------------------------------------------------------------
*/

// No direct access to this file
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.methods' );

// classe du Module
class modiCcalendarHelper
{
	private function construct($params)
	{
		$this->catid = $params->get('mcatid');
		$this->time = $params->get('time');
		$this->number = $params->get('number');
		if (!$_GET['page']){
			$this->start='0';
		}
		if ($_GET['page']){
			$this->start = $number*($_GET['page']-1);
		}
		$this->template=$params->get('template');
		$this->format= $params->get('format');
		$this->itemid= $params->get('itemid');
		//Add Security 
		$id = $_GET["id"];
		if ((!$id) || (!preg_match("/^[0-9]+$/", $id))) {};
	
		$Itemid = $_GET["Itemid"];
		if ((!$Itemid) || (!preg_match("/^[0-9]+$/", $Itemid))) exit();
		if($this->itemid===NULL) $this->itemid = $Itemid;
		
		$this->date_start=date('Y-m-d');
		if(isset($_GET['date'])&&(!empty($_GET['date']))) $this->date_start=$_GET['date'];

		if($time==0) $this->addFilter('e.next', $this->date_start,'>=');
		if($this->catid!=0) $this->addFilter('e.catid', $this->catid);
	}

	function start($params)
	{
		$this->construct($params);
	}

	function addFilter($key, $var, $for=NULL){
		if($for==NULL) $for='=';
		$this->filter[$key]=' AND '.$key.$for.$var;
	}
	// Class Method
	function getStamp($params)
	{
		$this->start($params);
		// Prpare la requte
		$db		= JFactory::getDbo();
		$query	= $db->getQuery(true);
		
		// Slection de la requte
		$query->select(
			'e.id, e.title, e.alias, e.params, e.catid, e.image, e.file, e.next, e.dates, e.time, e.desc, e.address as address, e.place as place_name, e.city as city, e.coordinate as coordinate, c.title as cat_title, c.alias as cat_alias, c.color as cat_color' 
		);
		$query->from('`#__icagenda_events` AS e');
		$query->leftJoin('`#__icagenda_category` AS c ON c.id = e.catid');
		$query->leftJoin('`#__icagenda_events` AS l ON l.id = e.place');
		
		// where
		$where='e.state = 1';

		// ajout des filtres
		if(isset($this->filter)){
			foreach ($this->filter as $filter){
				$where.=$filter;
			}
		}

		$query->where($where);
		$query->order('e.next');
		$query.=' LIMIT 0, 1000';
		// requte
		$db->setQuery($query);
		$res = $db->loadObjectList();
		
		$days=$this->getDays($this->date_start, $this->format);
		
		foreach ($res as $r) {
			$next=$this->getNext($r->dates, $r->id);
			$datelist=$this->getDatelist($r->dates, $next);


			
			
// Requte Itemid
		$lang = JFactory::getLanguage();
		$locale = $lang->getlocale() ;
		setlocale( LC_TIME, $locale[0] ) ;

		$langcur = $lang->getTag();
		$langcurrent = $langcur;
		
		$db = JFactory::getDbo();
		$query	= $db->getQuery(true);
		$query->select('id AS idm, language AS lng')->from('#__menu')->where( "(link = 'index.php?option=com_icagenda&view=list') AND (published > 0) AND (language = '$langcurrent')" );
		$db->setQuery($query);
		$idm=$db->loadObject()->idm;
		$mItemid=$idm;
		
		if ($mItemid == NULL) {
		$db = JFactory::getDbo();
		$query	= $db->getQuery(true);
		$query->select('id AS noidm, language AS nolng')->from('#__menu')->where( "(link = 'index.php?option=com_icagenda&view=list') AND (published > 0) AND (language = '*')" );
		$db->setQuery($query);
		$noidm=$db->loadObject()->noidm;
		$noidm=$noidm;
		}
// Pour TESTS				echo "( $langcurrent ) - lg : $mItemid - nolg : $noidm";
		
		if ($noidm == NULL && $mItemid == NULL) {
			echo '<div style="color:#a40505; font-weight: bold; text-align: center;">'.JText::_( 'MOD_ICCALENDAR_COM_ICAGENDA_MENULINK_UNPUBLISHED_MESSAGE' ).'</div><br>';
			$nolink = 1;
		}			
		
		if ($nolink == 1) {
			$urlevent = '#';
		}else {
			$lien = $mItemid;
			$eventnumber = $r->id;
			$urlevent = JRoute::_('index.php?option=com_icagenda&amp;view=list&amp;layout=event&amp;Itemid='.$lien.$noidm.'&amp;id='.$eventnumber);
		}
		$event=array(
				'id' => $r->id,
				'url'=> $urlevent,
				'title' => $r->title,
				'image' => $r->image,
				'dates' => $r->dataini,
				'next' => date('Y-m-d', $next),
				'time' => $r->time,
				'address' => $r->address,
				'place' => $r->place,
				'cat_title' => $r->cat_title,
				'cat_color' => $r->cat_color,
			);

			foreach ($datelist as $d){
				foreach ($days as $k=>$dy){
					if($d==$dy['date']){
						array_push ($days[$k]['events'], $event);
					}
				}
			}
		}
		
		
		return $days;
	}
	/***/
	 
	// Gnration des jours du mois
	function getDays ($d, $f)
	{
		// dtermine le mois et l'anne

		$ex_data=explode('-', $d);
		$mese=$ex_data[1];
		$anno=$ex_data[0];

		// Gnration du Calendrier
		$days = date("d", mktime(0, 0, 0, $mese+1, 0, $anno));
		$list = array();
		for($a=1; $a<=$days; $a++)
		{
			$list[$a]['date'] = date('Y-m-d', mktime(0, 0, 0, $mese, $a, $anno));
			$list[$a]['dateFormat'] = date($f, mktime(0, 0, 0, $mese, $a, $anno));
			$list[$a]['week'] = date('N', mktime(0, 0, 0, $mese, $a, $anno));
			$list[$a]['day'] = $a;
			$list[$a]['month'] = $mese;
			$list[$a]['year'] = $anno;
			$list[$a]['events']=array();
		}
		return $list;
	}
	/***/
	
	/**
	 * liste des dates pour un vnement
	 */
	private function getDatelist($dates, $next)
	{
	
		$dates=unserialize($dates);
		$da=array();
		foreach($dates as $d){
			$d=$this->mkt($d);
			if($d>=$next){
				array_push($da, date('Y-m-d', $d));
			}
		}
		return $da;
	}

	private function mkt($data)
	{
		$ex_data=explode('-', $data);
		$ris=mktime('00', '00', '00', $ex_data['1'], $ex_data['2'], $ex_data['0']);
		return $ris;
	}
	
	private function addDay ($mkt) 
	{
		return $mkt+82800;
	}
	
	private function getNext ($dates, $id)
	{
		$dates=unserialize($dates);
		$today=time();
		$day= date('d');
		$m= date('m');
		$y= date('y');
		$today=mktime(0,0,0,$m,$day,$y);

		if(count($dates)){
			rsort($dates);
			if ($next <= $today) {
				$dd = $this->mkt($dates[0]);
				$next=$dd;
			foreach($dates as $a){
				$d=$this->mkt($a);
				if ($d>=$today){
					$next=date('Y-m-d', $d);
				}
			}
//			if ($d < $today) {
//			return date('Y-m-d', $next);
//			}
			}
		}
		$db		= Jfactory::getDbo();
		$query	= $db->getQuery(true);
		
		$query->update('#__icagenda_events')
			->set("`next`='".$next."'");
		$query->where('`id`='.$id);
		$db->setQuery($query);
		$db->query($query);
	}

	/***/

	/** Systme de navigation **/
	function getNav($date_start)
	{
		$option = 'index.php?option='.JRequest::getVar('option');
		$view = '&view='.JRequest::getVar('view');
		if(JRequest::getVar('layout'))$layout = '&layout='.JRequest::getVar('layout');
		$Itemid = '&Itemid='.JRequest::getVar('Itemid');
		if(JRequest::getVar('id'))$id = '&id='.JRequest::getVar('id');
		$Aurl = $option.$view.$layout.$Itemid.$id;


		$ex_date=explode('-', $date_start);
		$mkt_date=$this->mkt($date_start);
		$year=$ex_date[0];
		$month=$ex_date[1];
		$day=1;

		if($month!=1){$backMonth=$month-1; $backYear=$year;}
		if($month==1){$backMonth=12; $backYear=$year-1;}
		if($month!=12){$nextMonth=$month+1; $nextYear=$year;}
		if($month==12){$nextMonth=1; $nextYear=$year+1;}
		$back='<a class="back icagendabtn" href="'.$Aurl.'&date='.$backYear.'-'.$backMonth.'-'.$day.'">&#9668</a>';
		$next='<a class="next icagendabtn" href="'.$Aurl.'&date='.$nextYear.'-'.$nextMonth.'-'.$day.'">&#9658</a>';

		$title=date('M-Y', $mkt_date);
		$lang = JFactory::getLanguage();
		$locale = $lang->getlocale() ;
		setlocale( LC_TIME, $locale[0] ) ;
//+		/** translate the month in the calendar module -- Leland Vandervort **/
 		$dateFormat = $title;
-		$title = strftime("%B %Y",strtotime("$dateFormat"));
+		// split out the month and year to obtain translation key for JText using joomla core translation
+		$t_month = strftime("%B", strtotime("$dateFormat")); 
+		$t_year = strftime("%Y", strtotime("$dateFormat"));
+		// now resplice the title back together and call JText::
+		$title = JText::_(strtoupper($t_month)) . ' ' . $t_year;
//		$dateFormat = $title;
//		$title = strftime("%B %Y",strtotime("$dateFormat"));

		$html.='<div class="nav">'.$back.$next.'<div class="title" style="text-transform: uppercase;">'.$title.'</div></div>';

		return $html;
	}
	/***/
 
}
?>